@ECHO OFF
REM --- Installation batch file for 32bit and 64bit Windows OS
REM --- Version 2.02.002, by Martin Richter, (c) Grutzeck-Software GmbH
SETLOCAL
SET DIR=%~dp0
SET DIR=%DIR:~0,-1%

:START
REM --- Check for needed file
IF NOT EXIST "%DIR%\AGVIP-OutlookAddIn.vsto" GOTO :MissingFile
IF NOT EXIST "%DIR%\AGVIP-OutlookAddIn.dll" GOTO :MissingFile
IF NOT EXIST "%DIR%\AGVIP-OutlookAddIn.dll.manifest" GOTO :MissingFile
IF NOT EXIST "%DIR%\Grutzeck-Software GmbH.cer" GOTO :MissingFile

REM --- Check for Admin rights
NET SESSION >NUL 2>&1
IF ERRORLEVEL 1 GOTO :Elevated

CLS
If /I "%1"=="Unregister" GOTO :Unregister
If /I "%1"=="/Unregister" GOTO :Unregister
If /I "%1"=="Register" GOTO :Register
If /I "%1"=="/Register" GOTO :Register
If NOT "%1"=="" GOTO :Syntax

:Register
ECHO %DIR%
ECHO -------------------------------------------------------------------------
ECHO --- Press any key to register the AG-VIP SQL Outlook AddIn
ECHO --- Make sure that Outlook is not started.
ECHO -------------------------------------------------------------------------
PAUSE 

REM --- Add the certificate
ECHO Install certificate
certutil.exe -addstore TrustedPublisher "%DIR%\Grutzeck-Software GmbH.cer" >NUL
IF ERRORLEVEL 1 GOTO :ERROR

REM --- Remove old addin if existent.
REG QUERY "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIPSQLOLADDIN.Connect" /reg:32 2> NUL > NUL
IF ERRORLEVEL 1 GOTO :RegisterWin64

ECHO Unregister old Outlook Addin for 32bit (HKLM)
REG DELETE "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIPSQLOLADDIN.Connect" /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR

:RegisterWin64
IF "%ProgramW6432%"=="" GOTO :RegisterWin32

ECHO Register for 64bit Outlook (HKLM)
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v Description /t REG_SZ /d "Outlook AddIn for AG-VIP SQL" /f /reg:64 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v Manifest /t REG_SZ /d "file:\\\%DIR:\=/%\AGVIP-OutlookAddIn.vsto|vstolocal" /f /reg:64 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v FriendlyName /t REG_SZ /d "AG-VIP SQL Outlook AddIn" /f /reg:64 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v LoadBehavior /t REG_DWORD /d 3 /f /reg:64 > NUL
IF ERRORLEVEL 1 GOTO :ERROR

REM --- Enable VSTO from network drives
REG ADD "HKLM\SOFTWARE\Microsoft\VSTO Runtime Setup\v4" /v EnableVSTOLocalUNC /t REG_DWORD /d 1 /f /reg:64 > NUL

:RegisterWin32
ECHO Register for 32bit Outlook (HKLM)
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v Description /t REG_SZ /d "Outlook AddIn for AG-VIP SQL" /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v Manifest /t REG_SZ /d "file:\\\%DIR:\=/%\AGVIP-OutlookAddIn.vsto|vstolocal" /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v FriendlyName /t REG_SZ /d "AG-VIP SQL Outlook AddIn" /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR
REG ADD "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /v LoadBehavior /t REG_DWORD /d 3 /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR

REM --- Enable VSTO from network drives
REG ADD "HKLM\SOFTWARE\Microsoft\VSTO Runtime Setup\v4" /v EnableVSTOLocalUNC /t REG_DWORD /d 1 /f /reg:32 > NUL

ECHO -------------------------------------------------------------------------
ECHO --- RegisterAGVIPOutlookAddIn.BAT succeeded!
ECHO --- The Outlook AddIn was registered successfully. You may need to
ECHO --- restart Outlook now.
ECHO -------------------------------------------------------------------------

GOTO :Exit

:Unregister
ECHO %DIR%
ECHO -------------------------------------------------------------------------
ECHO --- Press any key to unregister the AG-VIP SQL Outlook AddIn
ECHO -------------------------------------------------------------------------
PAUSE 

REM --- Remove old addin if existent.
REG QUERY "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIPSQLOLADDIN.Connect" /reg:32 2> NUL > NUL
IF ERRORLEVEL 1 GOTO :UnregisterHKCU

ECHO Unregister old Outlook Addin for 32bit (HKLM)
REG DELETE "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIPSQLOLADDIN.Connect" /f /reg:32 > NUL
IF ERRORLEVEL 1 GOTO :ERROR

:UnregisterHKCU
REG QUERY "HKCU\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" 2> NUL > NUL
IF ERRORLEVEL 1 GOTO :UnregisterWin64HKLM

ECHO Unregister for 32bit Outlook (HKCU)
REG DELETE "HKCU\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /f > NUL

:UnregisterWin64HKLM
IF "%ProgramW6432%"=="" GOTO :UnregisterWin32HKLM

REG QUERY "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /reg:64 2> NUL > NUL
IF ERRORLEVEL 1 GOTO :UnregisterWin32HKLM

ECHO Unregister for 64bit Outlook (HKLM)
REG DELETE "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /f /reg:64 > NUL
IF ERRORLEVEL 1 GOTO :ERROR

:UnregisterWin32HKLM
REG QUERY "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /reg:32 2> NUL > NUL
IF ERRORLEVEL 1 GOTO :UnregisterDone

ECHO Unregister for 32bit Outlook (HKLM)
REG DELETE "HKLM\Software\Microsoft\Office\Outlook\Addins\AGVIP-OutlookAddIn" /f /reg:32 > NUL

:UnregisterDone
ECHO -------------------------------------------------------------------------
ECHO --- RegisterAGVIPOutlookAddIn.BAT succeeded!
ECHO --- The Outlook AddIn was unregistered successfully. You may need to
ECHO --- restart Outlook now.
ECHO -------------------------------------------------------------------------

GOTO :Exit

:Syntax
ECHO -------------------------------------------------------------------------
ECHO --- To REGISTER the Addin use 
ECHO ---      RegisterAGVIPOutlookAddIn.bat REGISTER
ECHO ---   or   
ECHO ---      RegisterAGVIPOutlookAddIn.bat /REGISTER
ECHO ---
ECHO --- To UNREGISTER the Addin use 
ECHO ---      RegisterAGVIPOutlookAddIn UNREGISTER
ECHO ---   or   
ECHO ---      RegisterAGVIPOutlookAddIn.bat /UNREGISTER
ECHO -------------------------------------------------------------------------
PAUSE
EXIT /B:12

:Elevated
ECHO -------------------------------------------------------------------------
ECHO --- RegisterAGVIPOutlookAddIn.BAT failed!
ECHO --- You need to run this batch file as Administrator!
ECHO -------------------------------------------------------------------------
PAUSE
EXIT /B:12

:MissingFile
ECHO -------------------------------------------------------------------------
ECHO --- RegisterAGVIPOutlookAddIn.BAT failed!
ECHO --- One or more of the required files are missing:
ECHO ---   AGVIP-OutlookAddIn.vsto 
ECHO ---   AGVIP-OutlookAddIn.dll 
ECHO ---   AGVIP-OutlookAddIn.dll.manifest 
ECHO ---   Grutzeck-Software GmbH.cer 
ECHO --- This file must be located in the installation directory
ECHO -------------------------------------------------------------------------
PAUSE
EXIT /B:12

:Error
ECHO -------------------------------------------------------------------------
ECHO --- RegisterAGVIPOutlookAddIn.BAT failed!
ECHO --- An error occurred registering the Outlook Addin!
ECHO -------------------------------------------------------------------------
PAUSE
EXIT /B:12

:Exit
PAUSE
EXIT /B:0